#import "IndigitallFlutterPlugin.h"
#import <Indigitall/InAppUtils.h>
#import "IndigitallInboxFlutterPlugin.h"
#import <Indigitall/EventRequestInApp.h>
#import <Indigitall/InAppAPIClient.h>
#import <Indigitall/InAppHandler.h>
#import <IndigitallCustomerFlutterPlugin.h>

@implementation IndigitallFlutterPlugin

NSString *INIT = @"initialize";
NSString *DEVICE_ENABLE = @"deviceEnable";
NSString *DEVICE_DISABLED = @"deviceDisable";
NSString *TOPICS_LIST = @"topicsList";
NSString *TOPICS_SUBSCRIBE = @"topicsSubscribe";
NSString *TOPICS_UNSUBSCRIBE = @"topicsUnsubscribe";
NSString *SET_EXTERNAL_CODE = @"setExternalCode";
NSString *SEND_CUSTOM_EVENT = @"sendCustomEvent";
NSString *PACKAGE_NAME = @"packageName";
NSString *GET_PUSH = @"getPush";
NSString *LOG_IN = @"logIn";
NSString *LOG_OUT = @"logOut";

NSString *GET_INAPP = @"getInApp";
NSString *TAP_INAPP = @"tapInApp";
NSString *SHOW_POP_UP = @"showPopUp";
NSString *ACTION_ADD_NEW_INAPP_TO_DISMISS_FOREVER = @"addNewInAppToDismissForever";

NSString *ACTION_GET_INBOX_COUNT = @"getMessageCount";
NSString *ACTION_GET_INBOX = @"getInbox";
NSString *ACTION_GET_NEXT_PAGE = @"getNextPage";
NSString *ACTION_MASSIVE_EDIT_NOTIFICATIONS = @"massiveEditNotificationsWithSendingIdsList";
NSString *ACTION_INFO_NOTIFICATION = @"getInfoFromNotificationWithSendingId";
NSString *ACTION_MODIFY_STATUS_NOTIFICATION = @"modifyStatusFromNotificationWithSendingId";
NSString *ACTION_GET_AUTH_CONFIG = @"getAuthConfig";

NSString *ACTION_GET_CUSTOMER = @"getCustomer";
NSString *ACTION_GET_CUSTOMER_INFORMATION = @"getCustomerInformation";
NSString *ACTION_UPDATE_VALUE_CUSTOMER_FIELDS = @"assignOrUpdateValueToCustomerFields";
NSString *ACTION_DELETE_VALUES_CUSTOMER_FIELDS = @"deleteValuesFromCustomerFields";
NSString *ACTION_LINK = @"link";
NSString *ACTION_UNLINK = @"unlink";

NSString *CALLBACK_ON_INDIGITALL_INITIALIZED = @"callbackOnIndigitallInitialized";
NSString *CALLBACK_DEVICE_ENABLE = @"callbackDeviceEnabled";
NSString *CALLBACK_DEVICE_DISABLE = @"callbackDeviceDisEnabled";
NSString *CALLBACK_TOPIC_LIST = @"callbackTopicList";
NSString *CALLBACK_TOPIC_SUBSCRIBE = @"callbackTopicSubscribe";
NSString *CALLBACK_TOPIC_UNSUBSCRIBE = @"callbackTopicUnsubscribe";
NSString *CALLBACK_EXTERNAL_CODE = @"callbackExternalCode";
NSString *CALLBACK_SEND_CUSTOM_EVENT = @"callbackSendCustomEvent";
NSString *CALLBACK_LOGIN = @"callbackLogin";
NSString *CALLBACK_LOGOUT = @"callbackLogout";
NSString *CALLBACK_SHOW_POPUP = @"callbackShowPopUp";
NSString *CALLBACK_DID_CLICKED = @"callbackDidClicked";
NSString *CALLBACK_DID_CLOSED = @"callbackDidClosed";
NSString *CALLBACK_DID_DISMISSED = @"callbackDidDismissed";
NSString *CALLBACK_SHOWTIME_FINISHED = @"callbackShowTimeFinished";

Inbox *myInbox;

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
//  [SwiftIndigitallFlutterPlugin registerWithRegistrar:registrar];
    FlutterMethodChannel *channel = [FlutterMethodChannel methodChannelWithName:@"indigitall_flutter_plugin" binaryMessenger:registrar.messenger];
    [channel setMethodCallHandler:^(FlutterMethodCall * _Nonnull call, FlutterResult  _Nonnull result) {
        if ([call.method isEqual:INIT]){
            [self initialize:call.arguments result:result];
        } else if ([call.method isEqual:DEVICE_ENABLE]){
            [self deviceEnable:result];
        } else if ([call.method isEqual:DEVICE_DISABLED]){
            [self deviceDisable:result];
        } else if ([call.method isEqual:TOPICS_LIST]){
            [self topicsList:result];
        } else if ([call.method isEqual:TOPICS_SUBSCRIBE]){
            [self topicsSubscribe:call.arguments result:result];
        } else if ([call.method isEqual:TOPICS_UNSUBSCRIBE]){
            [self topicsUnsubscribe:call.arguments result:result];
        } else if ([call.method isEqual:SET_EXTERNAL_CODE]){
            [self setExternalCode:call.arguments result:result];
        } else if ([call.method isEqual:SEND_CUSTOM_EVENT]){
            [self sendCustomEvent:call.arguments result:result];
        } else if ([call.method isEqual:PACKAGE_NAME]){
            [self packageName:result];
        } else if ([call.method isEqual:LOG_IN]){
            [self logIn:call.arguments result:result];
        } else if ([call.method isEqual:LOG_OUT]){
            [self logOut:result];
        } else if ([call.method isEqual:GET_INAPP]) {
             [self getInApp: call.arguments result: result];
        }  else if ([call.method isEqual:TAP_INAPP]) {
            [self tapInApp: call.arguments result: result];
        } else if ([call.method isEqual:ACTION_ADD_NEW_INAPP_TO_DISMISS_FOREVER]) {
            [self addNewInAppToDismissForever:call.arguments];
        } else if ([call.method isEqual:SHOW_POP_UP]) {
            [self showPopUp: call.arguments result: result];
        } else if ([call.method isEqual:ACTION_GET_INBOX_COUNT]) {
            [[IndigitallInboxFlutterPlugin alloc] getInboxMessagesCountWithArguments:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_GET_INBOX]) {
            [[IndigitallInboxFlutterPlugin alloc]  getInboxWithArguments:call.arguments success:^(Inbox *inbox) {
                myInbox = inbox;
            } result:result];
        } else if ([call.method isEqual:ACTION_GET_NEXT_PAGE]) {
            [[IndigitallInboxFlutterPlugin alloc]  getNextPageWithArguments:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_MASSIVE_EDIT_NOTIFICATIONS]) {
            [[IndigitallInboxFlutterPlugin alloc]  massiveEditNotificationsWithSendingIdsList:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_INFO_NOTIFICATION]) {
            [[IndigitallInboxFlutterPlugin alloc]  getInfoFromNotificationWithSendingId:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_MODIFY_STATUS_NOTIFICATION]) {
            [[IndigitallInboxFlutterPlugin alloc]  modifyStatusFromNotificationWithSendingId:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_GET_AUTH_CONFIG]) {
            [[IndigitallInboxFlutterPlugin alloc] setAuth:call.arguments];
        } else if ([call.method isEqual:ACTION_GET_CUSTOMER]) {
            [IndigitallCustomerFlutterPlugin getCustomer:result];
        } else if ([call.method isEqual:ACTION_GET_CUSTOMER_INFORMATION]) {
            [IndigitallCustomerFlutterPlugin getCustomerInformation:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_LINK]) {
            [IndigitallCustomerFlutterPlugin link:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_UNLINK]) {
            [Indigitall logOutWithSuccess:^(INDevice * _Nonnull device) {
                [IndigitallCustomerFlutterPlugin unlink:call.arguments result:result];
            } onError:^(INError * _Nonnull error) {
                [self jsonFromError: error withResult:result];
            }];
        } else if ([call.method isEqual:ACTION_UPDATE_VALUE_CUSTOMER_FIELDS]) {
            [IndigitallCustomerFlutterPlugin assignOrUpdateValueToCustomerFields:call.arguments result:result];
          
        } else if ([call.method isEqual:ACTION_DELETE_VALUES_CUSTOMER_FIELDS]) {
            [IndigitallCustomerFlutterPlugin deleteValuesFromCustomerFields:call.arguments result:result];
        }
    }];
}


+ (void) initialize: (NSDictionary *)params result: (FlutterResult _Nonnull)result {
      NSString *appKey = params[@"appKey"];

      NSLog(@"params: %@",params);
      INConfig *config = [[INConfig alloc]initWithAppKey:appKey];

      config.pushPermissionMode = automatic;
      if(params[@"requestLocation"]){
          config.locationPermissionMode = automatic;
      }else{
          config.locationPermissionMode = manual;
      }

      if (params[@"wifiFilterEnabled"]){
          config.wifiFilterEnabled = params[@"wifiFilterEnabled"];
      }

      if (params[@"urlDeviceApi"]) config.domain = params[@"urlDeviceApi"];
      if (params[@"urlInAppApi"]) config.domainInApp = params[@"urlInAppApi"];
      if (params[@"urlInboxApi"]) config.domainInbox = params[@"urlInboxApi"];

      [config setProductName:params[@"productName"]];
      [config setProductVersion:params[@"productVersion"]];
      
      [Indigitall askNotificationPermission];
      [Indigitall initializeWithConfig:config onIndigitallInitialized:^(NSArray<INPermissions *> * _Nonnull permissions, INDevice * _Nonnull device) {
            [self jsonFromDevice:device withKey:CALLBACK_ON_INDIGITALL_INITIALIZED withResult:result];
          } onErrorInitialized:^(INError * _Nonnull onError) {
              [self jsonFromError:onError withResult:result];
      }];
      
  }

+ (void) packageName: (FlutterResult _Nonnull)result{
    NSString *bundleIdentifier = [[NSBundle mainBundle] bundleIdentifier];
    [self resultFromString:bundleIdentifier withAction:PACKAGE_NAME withResult:result];
}

+ (void) deviceEnable: (FlutterResult _Nonnull)result {
    
    [Indigitall enableDeviceWithOnSuccess:^(INDevice * _Nonnull device) {
        [self jsonFromDevice:device withKey:CALLBACK_DEVICE_ENABLE withResult:result];
    } onError:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}

+ (void) deviceDisable: (FlutterResult _Nonnull)result {
    
    [Indigitall disableDeviceWithOnSuccess:^(INDevice * _Nonnull device) {
        [self jsonFromDevice:device withKey:CALLBACK_DEVICE_DISABLE withResult:result];
    } onError:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}

+ (void) topicsList: (FlutterResult _Nonnull)result{
    
    [Indigitall topicsListWithOnSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
        [self resultFromTopic:[self jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_LIST withResult:result];
    } onError:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}

+ (void) topicsSubscribe: (id)object result: (FlutterResult _Nonnull)result{
    if (![object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray* params = object;
        NSMutableArray<INTopic *>* topicsList = [[NSMutableArray alloc]init];
        for (int i = 0; i < params.count; i++) {
           INTopic *topic = [[INTopic alloc]init:params[i]];
           topicsList[i] = topic;
        }

        [Indigitall topicsSubscribeWithTopic:topicsList onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [self resultFromTopic:[self jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_SUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
        }];
       
    }else if ([object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray<NSString *>* params = object;
         [Indigitall topicsSubscribeWithArrayString:params onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
             [self resultFromTopic:[self jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_SUBSCRIBE withResult:result];
         } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
         }];
    }else{
        [self jsonFromError: [[INError alloc]initWithErrorCode:1400 errorMessage:@"topicsSubscribe is not defined"] withResult:result];
    }
}

+ (void) topicsUnsubscribe: (id)object result: (FlutterResult _Nonnull)result{
    if (![object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray* params = object;
        NSMutableArray<INTopic *>* topicsList = [[NSMutableArray alloc]init];
        for (int i = 0; i < params.count; i++) {
          INTopic *topic = [[INTopic alloc]init:[params[i] mutableCopy]];
          topicsList[i] = topic;
        }
        [Indigitall topicsUnSubscribeWithTopic:topicsList onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [self resultFromTopic:[self jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_UNSUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
           [self jsonFromError: error withResult:result];
        }];
    }else if ([object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray<NSString *>* params = object;
        [Indigitall topicsUnSubscribeWithArrayString:params onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [self resultFromTopic:[self jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_UNSUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
        }];
    }else{
        [self jsonFromError: [[INError alloc]initWithErrorCode:1400 errorMessage:@"topicsUnsubscribe is not defined"] withResult:result];
    }
}

+ (void) setExternalCode: (id )object result: (FlutterResult _Nonnull)result {
    NSString *params = object;
    if (params != nil){
        [Indigitall setExternalCode:params onSuccess:^(INDevice * _Nonnull device) {
            [self jsonFromDevice:device withKey:CALLBACK_EXTERNAL_CODE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
        }];
    }else{
        [self jsonFromError: [[INError alloc]initWithErrorCode:1800 errorMessage:@"setExternalCode is not defined"] withResult:result];
    }
}

+ (void) sendCustomEvent: (NSDictionary *)params result: (FlutterResult _Nonnull)result{
    NSString *event;
    NSDictionary *customData;
    if (params[@"event"]) event = params[@"event"];
    if ([params[@"customData"] isKindOfClass:[NSString class]]){
        NSData *data = [params[@"customData"] dataUsingEncoding:NSUTF8StringEncoding];
        customData = [NSJSONSerialization JSONObjectWithData:data options:0 error:nil];
    }else{
        if (params[@"customData"]) customData = params[@"customData"];
    }
    
    if (params != nil){
        [Indigitall sendCustomEvent:event customData:customData onSuccess:^{
            [self resultFromString: @"event success" withAction: CALLBACK_SEND_CUSTOM_EVENT withResult:result];
        } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
        }];
    }else{
        [self jsonFromError: [[INError alloc]initWithErrorCode:1600 errorMessage:@"sendCustomEvent is not defined"] withResult:result];
    }
}

//+ (void) getPush: (FlutterResult _Nonnull)result{
//
//    [[NSNotificationCenter defaultCenter] addObserverForName:@"IndigitallHandleWithNotificationPush" object:nil queue:nil usingBlock:^(NSNotification * _Nonnull note) {
//        if ([[NSUserDefaults standardUserDefaults] dictionaryForKey:@"IndigitallHandleWithNotificationPush"] != nil){
//            if ((UIWebView *)self.webView != nil) [(UIWebView *)self.webView reload];
//        }
//    }];
//
//
//    NSDictionary *dictionaryPush = [[NSUserDefaults standardUserDefaults] dictionaryForKey:@"IndigitallHandleWithNotificationPush"];
//     if (dictionaryPush != nil){
//         [[NSUserDefaults standardUserDefaults] setObject:nil forKey:@"IndigitallHandleWithNotificationPush"];
//         result(dictionaryPush);
//     }else{
//         [self jsonFromError: [[INError alloc]initWithErrorCode:501 errorMessage:@"getPush is not defined"]];
//     }
//}

+ (void) logIn: (id)object result: (FlutterResult _Nonnull)result{
    NSString *params = object;
    if (params != nil){
        [Indigitall logInWithId:params onSuccess:^(INDevice * _Nonnull device) {
            [self jsonFromDevice:device withKey:CALLBACK_LOGIN withResult:result];
        } onError:^(INError * _Nonnull error) {
            [self jsonFromError: error withResult:result];
        }];
    }else{
        [self jsonFromError:  [[INError alloc]initWithErrorCode:1500 errorMessage:@"logIn is not defined"] withResult:result];
    }
}

+ (void) logOut: (FlutterResult _Nonnull)result{
    [Indigitall logOutWithSuccess:^(INDevice * _Nonnull device) {
        [self jsonFromDevice:device withKey:CALLBACK_LOGOUT withResult:result];
    } onError:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}

+ (void) getInApp:(id )object result: (FlutterResult _Nonnull)result{
    NSString *inAppId = object;
    [[[InAppHandler alloc]init]getInApp:inAppId success:^(NSString * _Nonnull content, INInApp * _Nonnull inApp) {
        if (inApp.properties.dismissForever &&
            [InAppUtils isInAppDismissForever:inApp]){
            [self inAppJsonFromError:@"2104" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:INErrorUtils.POP_UP_DISMISS_FOREVER] withResult:result];
        } else {
            [InAppUtils inAppWasShownWithInApp:inApp didExpired:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
                [self inAppJsonFromError:@"2101" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:INErrorUtils.INAPP_EXPIRED] withResult:result];
            } didShowMoreThanOnce:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
                [self inAppJsonFromError:@"2102" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:[NSString stringWithFormat:@"%@ %d times", INErrorUtils.INAPP_CLICK_OUT, inApp.properties.numberOfShows]] withResult:result];
            } didClickOut:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
                [self inAppJsonFromError:@"2103" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:[NSString stringWithFormat:@"%@ %d times", INErrorUtils.INAPP_TIMES_CLICKED, inApp.properties.numberOfClicks]] withResult:result];
            } onSuccess:^{
                [self jsonFromInApp:inApp withResult:result];
            }];
        }
    } errorLoad:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}

+ (void) tapInApp: (NSDictionary *)params result: (FlutterResult _Nonnull) result {
    INInApp *inApp = [[INInApp alloc]initWithJson:params];
    NSURL *url;
    if (inApp.properties.action.noAction == nil){
        EventRequestInApp *request = [[EventRequestInApp alloc]initWithInAppId:inApp.inAppId lastVersionId:inApp.lastVersionId];
        [InAppAPIClient postEventRequest:request completion:[[BaseCallback alloc]init]];
        if (inApp.properties.action.app != nil){
            url = [NSURL URLWithString:inApp.properties.action.app];
        }else if (inApp.properties.action.url != nil){
            url = [NSURL URLWithString:inApp.properties.action.url];
        }
        if (inApp.properties.numberOfClicks > 0) {
            [InAppUtils addInAppNewClick:inApp];
        }
    }

    if (url != nil && [UIApplication.sharedApplication canOpenURL:url]){
        if (@available(iOS 10.0, *)) {
            [UIApplication.sharedApplication openURL:url options:[[NSDictionary alloc] init] completionHandler:nil];
        }else{
            [UIApplication.sharedApplication openURL:url];
        }
    }
}

+ (void) addNewInAppToDismissForever:(NSDictionary *)params {
    INInApp *inApp = [[INInApp alloc]initWithJson:params];
    if (inApp != nil) {
        [InAppUtils addNewInAppToDismissForever:inApp];
    }
}

+ (void) showPopUp: (NSDictionary *)params result: (FlutterResult _Nonnull) result {
    NSString *inAppCode;
    BOOL closeIconDisabled = false;
    NSString *closeIconName;
    UIButton *button;
    if (params[@"popUpCode"]) inAppCode = params[@"popUpCode"];
    if ([params[@"closeIconDisabled"]boolValue] ==  true) closeIconDisabled = true;
    if (params[@"closeButton"]){
        closeIconName = params[@"closeButton"];
        button = [[UIButton alloc]init];
        [button setImage:[UIImage imageNamed:closeIconName] forState:normal];
        [button setTranslatesAutoresizingMaskIntoConstraints:false];
    }
    [Indigitall showPopup:inAppCode closeIcon:button closeIconDisabled:closeIconDisabled didAppear:^{
        NSDictionary *dic = @{
            @"inAppCode": inAppCode,
        };
        result(@{CALLBACK_SHOW_POPUP:dic});
    } didCancel:^{
        result(@{CALLBACK_DID_CLOSED:@""});
    } didClicked:^{
        result(@{CALLBACK_DID_CLICKED:@""});
    } didDismissed:^{
        result(@{CALLBACK_DID_DISMISSED:@""});
    } onShowTimeFinished:^(INInApp * _Nonnull inApp, int showTime) {
        NSDictionary *dic = @{
            @"showtime": [@(showTime) stringValue],
            @"inAppCode": inAppCode,
        };
        result(@{CALLBACK_SHOWTIME_FINISHED:dic});
    } didExpired:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
        [self inAppJsonFromError:@"2101" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:INErrorUtils.INAPP_EXPIRED] withResult:result];
    } didShowMoreThanOnce:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
        [self inAppJsonFromError:@"2102" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:[NSString stringWithFormat:@"%@ %d times", INErrorUtils.INAPP_CLICK_OUT, inApp.properties.numberOfShows]] withResult:result];
    } didClickOut:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
        [self inAppJsonFromError:@"2103" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:[NSString stringWithFormat:@"%@ %d times", INErrorUtils.INAPP_TIMES_CLICKED, inApp.properties.numberOfClicks]] withResult:result];
    } didDismissForever:^(INInApp * _Nonnull inApp, INError * _Nonnull error) {
        [self inAppJsonFromError:@"2104" error:[[INError alloc]initWithErrorCode:INAPP_SHOW_POPUP_ERROR errorMessage:INErrorUtils.POP_UP_DISMISS_FOREVER] withResult:result];
    } failed:^(INError * _Nonnull error) {
        [self jsonFromError: error withResult:result];
    }];
}


+ (void)jsonFromDevice: (INDevice *)device withKey: (NSString *)key withResult: (FlutterResult _Nonnull)result{
    NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
    NSMutableDictionary *deviceDict = [[NSMutableDictionary alloc]init];
    if (device != nil) {
        obj = [@{
            @"enable" : device.enabled,
            @"deviceId": device.deviceID ?: @"",
            @"pushToken" : device.pushToken ?: @"",
            @"platform": device.platform ?: @"",
            @"version": device.sdkVersion  ?: @"",
            @"productName" : device.productName  ?: @"",
            @"productVersion" : device.productVersion  ?: @"",
            @"osName": device.osName  ?: @"",
            @"osVersion": device.osVersion  ?: @"",
            @"deviceBrand": device.deviceBrand ?: @"",
            @"deviceModel": device.deviceModel ?: @"",
            @"operator": device.carrier ?: @"",
            @"deviceType": device.deviceType ?: @"",
            @"appVersion": device.appVersion ?: @"",
            @"locale": device.locale ?: @"",
            @"timeZone": device.timeZone ?: @"",
            @"timeOffset": @(device.timeOffset) ?: 0,
            @"externalApps": [self jsonArrayFromExternalApps: device.externalApplications]
        } mutableCopy];
    }
    [deviceDict setValue:[obj copy] forKey:key];
    result([deviceDict copy]);
}

+ (NSArray<NSDictionary *>*) jsonArrayFromExternalApps: (NSArray<INExternalApp *>*)externalApps{
    NSArray<NSDictionary *>* array = [NSArray new];
    @try{
        if (externalApps != nil){
            for (int i=0;i<externalApps.count;i++){
                NSDictionary *obj = [[NSDictionary alloc]init];
                obj = @{
                @"id" : @(externalApps[i].iNExternalAppId) ?: 0,
                @"name": externalApps[i].name ?: @"",
                @"code" : externalApps[i].iosCode ?: @"",
                };
                array = [array arrayByAddingObject:obj];
            }
        }
    } @catch (NSException *exception) {
        NSLog(@"Error jsonArrayFromExternalApps ");
    }
    return array;
}

+ (NSArray<NSDictionary *>*) jsonArrayFromTopics: (NSArray<INTopic *>*) topics{
    NSArray<NSDictionary *>* array = [NSArray new];
    @try{
        for (int i=0;i<topics.count;i++){
            NSDictionary *obj = [[NSDictionary alloc]init];
            obj = @{
                @"code" : topics[i].code ?: @"",
                @"name": topics[i].name ?: @"",
                @"parentCode" : topics[i].parentCode ?: @"",
                @"visible" :@(topics[i].visible) ?: false,
                @"subscribed" :@(topics[i].subscribed) ?: false
            };
            array = [array arrayByAddingObject:obj];
            
        }
    } @catch (NSException *exception) {
        NSLog(@"Error jsonArrayFromTopics %@", exception);
    }
    return array;
}

+ (void) jsonFromInApp: (INInApp *)inApp  withResult: (FlutterResult _Nonnull) result {
    NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
    NSMutableDictionary *inAppDict = [[NSMutableDictionary alloc]init];
    if (inApp != nil) {
        
        obj = [@{
            @"inAppId" : @(inApp.inAppId),
            @"showOnce" : @(inApp.showOnce) ?: 0,
            @"creationDate" : inApp.creationDate ?: @"",
            @"expiredDate" : inApp.expiredDate  ?: @"",
            @"properties": @{
              @"action": [self jsonFromInAppAction: inApp.properties.action],
              @"contentUrl": inApp.properties.InAppContentUrl.absoluteString,
              @"showTime": @(inApp.properties.showTime) ?: 0,
              @"numberOfShows": @(inApp.properties.numberOfShows)  ?: 0,
              @"numberOfClicks": @(inApp.properties.numberOfClicks)  ?: 0,
              @"dismissForever": @(inApp.properties.dismissForever) ?: false,
            },
            @"layout": [self jsonFromInAppLayout: inApp.properties.layout],
            @"schema": @{
                    @"width": @(inApp.InAppWidth),
                    @"height": @(inApp.InAppHeight),
                    @"code": inApp.code,
                }
        } mutableCopy];
    }
    [inAppDict setValue:[obj copy] forKey:@"callbackGetInApp"];
    result([inAppDict mutableCopy]);
}

+ (NSDictionary *) jsonFromInAppAction: (INInAppAction *)action{
    NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
    if (action != nil){
        if (action.destroy) [obj setValue:@(action.destroy) forKey:@"destroy"];
        if (action.topics) [obj setValue:action.topics forKey:@"topics"];
        if (action.type) [obj setValue:@(action.type) forKey:@"type"];
        if (action.app) [obj setValue:action.app forKey:@"app"];
        if (action.url) [obj setValue:action.url forKey:@"url"];
        if (action.call) [obj setValue:action.call forKey:@"call"];
        if (action.market) [obj setValue:action.market forKey:@"market"];
        if (action.share) [obj setValue:action.share forKey:@"share"];
    }
    return [obj copy];
}

+ (NSDictionary *) jsonFromInAppLayout: (INInAppLayout *)layout{
    NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
    if (layout!= nil){
        if (layout.borderRadius) [obj setValue:@(layout.borderRadius) forKey:@"borderRadius"];
        
    }
    return [obj copy];
}

+ (void) resultFromString: (NSString *)string withAction: (NSString *)action withResult: (FlutterResult _Nonnull) result {
    NSMutableDictionary *dic = [NSMutableDictionary new];
    @try {
        dic = [@{
        action : string
        } mutableCopy];
    } @catch (NSException *exception) {
        result([FlutterError errorWithCode:action message:[NSString stringWithFormat:@"Error jsonFromError %@", exception] details:nil]);
    }
    result([dic copy]);
}

+ (void) resultFromTopic: (NSArray<NSDictionary *>*) topics key: (NSString *) key withResult: (FlutterResult _Nonnull) result {
    NSMutableDictionary *dict = [NSMutableDictionary new];
    [dict setValue:topics forKey:key];
    result([dict copy]);
}

+ (void) jsonFromError: (INError *)error withResult: (FlutterResult _Nonnull) result {
    result([FlutterError errorWithCode:[NSString stringWithFormat:@"%u",error.errorCode] message:error.message details:nil]);
}

+ (void) inAppJsonFromError: (NSString *)errorCodeString error:(INError *)error withResult: (FlutterResult _Nonnull) result {
    result([FlutterError errorWithCode:errorCodeString message:error.message details:nil]);
}
@end
