import 'dart:convert';

class ExternalApp {
  /// String field name id
  static const String JSON_ID = "id";

  /// String field name name
  static const String JSON_NAME = "name";

  /// String field name android code
  static const String JSON_ANDROID_CODE = "androidCode";

  /// id of external app
  int? id;

  /// name of externall app
  String? name;

  /// android code of app
  String? androidCode;

  ExternalApp(int? id, String? name, String? androidCode) {
    this.id = id;
    this.name = name;
    this.androidCode = androidCode;
  }

  static List<ExternalApp> createArray(String externalApp) {
    List<dynamic> list = json.decode(externalApp);
    List<ExternalApp> externalApps = [];
    for (int i = 0; i < list.length; i++) {
      ExternalApp? app = new ExternalApp(null, null, null);
      list[i].forEach((key, value) {
        if (key == ExternalApp.JSON_ID) app.id = int.parse(value);
        if (key == ExternalApp.JSON_ANDROID_CODE)
          app.androidCode = value.toString();
        if (key == ExternalApp.JSON_NAME) app.name = value.toString();
        externalApps.add(app);
      });
    }
    return externalApps;
  }

  Map toMap() {
    Map map = Map();
    if (id != null) map[JSON_ID] = id;
    if (name != null) map[JSON_NAME] = name;
    if (androidCode != null) map[JSON_ANDROID_CODE] = androidCode;
    return map;
  }

  @override
  String toString() {
    return json.encode(toMap());
  }
}
