import 'dart:convert';

import 'PushAction.dart';

class PushButton {
  /// String field name  buttons
  static const String BUTTONS = "buttons";

  /// String field name label
  static const String _LABEL = "label";

  /// String field name action
  static const String _ACTION = PushAction.ACTION;

  /// String field name topics
  static const String _TOPICS = "topics";

  /// label of button
  String? label;

  /// action of button
  PushAction? action;

  /// list of topics if press button
  List<String>? topics;

  /// Constructor of [PushButton]
  PushButton(Map map) {
    map.forEach((key, value) {
      switch (key) {
        case _LABEL:
          label = value.toString();
          break;
        case _ACTION:
          action = PushAction(json.decode(value.toString()));
          break;
        case _TOPICS:
          topics = json.decode(value.toString());
          break;
      }
    });
  }

  /// Conversion to [Map]
  Map toMap() {
    Map map = Map();
    if (label != null) map[_LABEL] = label;
    if (action != null) map[_ACTION] = action;
    if (topics != null) map[_TOPICS] = topics;
    return map;
  }
}
